#include "chdecl.h"
void CH_profdetail(current, sched, cop)
#define ARGUMENTS 6
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb9;
    case 2: goto c10;
    case 3: goto c26;
    case 4: goto c28;
    case 5: goto cb30;
    case 6: goto c31;
    case 7: goto cb32;
    case 8: goto c33;
    case 9: goto c36;
    case 10: goto cb41;
    case 11: goto c42;
    case 12: goto c44;
    case 13: goto cb49;
    case 14: goto c50;
    case 20: goto c52;
    case 15: goto c52;
    case 16: goto cb55;
    case 17: goto c56;
    case 18: goto cb57;
    case 19: goto c58;
    case 21: goto c60;
    case 22: goto c63;
    case 23: goto c66;
    case 24: goto c71;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
/* prog_lit 3 , 1 */
  if ((ch_returncode = che_prog_lit(DEF(3),QUAL(1),sched)) != Normal) 
     goto ch_raise_exception;
/* procedure 4 3 , 2 */
  if ((ch_returncode = che_procedure(DEF(4),DEF(3),QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
/* discard 3 */
  (*(REF(3).tsdr)->finalize)(REF(3).value,F_DISCARD,sched);
  REF(3).tsdr = & dr_bottom;
/* move 5 4 */
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5) = REF(4);
  REF(4).tsdr = & dr_bottom;
/* prog_lit 6 , 3 */
  if ((ch_returncode = che_prog_lit(DEF(6),QUAL(3),sched)) != Normal) 
     goto ch_raise_exception;
/* procedure 7 6 , 4 */
  if ((ch_returncode = che_procedure(DEF(7),DEF(6),QUAL(4),sched)) != Normal)
     goto ch_raise_exception;
/* discard 6 */
  (*(REF(6).tsdr)->finalize)(REF(6).value,F_DISCARD,sched);
  REF(6).tsdr = & dr_bottom;
/* move 8 7 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8) = REF(7);
  REF(7).tsdr = & dr_bottom;
  current->ip = 1;
cb9:
/* receive 9 0 */
  if ((ch_returncode = che_receive(DEF(9),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c10:
/* copy 10 9.0 */
  if((ch_returncode = cp_table(& ch_val, REF(9)DOT(0).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(10).tsdr)->finalize)(REF(10).value,F_DISCARD,sched);
  REF(10).value = ch_val;
  REF(10).tsdr = & dr_table;
/* privatize 10 */
  if (REF(10).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(10))) != Normal)
       goto ch_raise_exception;
/* lookup_at 11 10 =(0) */
  if ( !((ch_t = REF(10).value.table)->size) ) goto ch_notfound;
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(11).value,0);
  REF(11).tsdr = qdatarepmap[ch_t->tsdr->number];
/* remove_at 12 10 =(0) */
  if ((ch_returncode = remove_at_func(DEF(12),DEF(10),0)) != Normal)
     goto ch_raise_exception;
/* privatize 10 */
  if (REF(10).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(10))) != Normal)
       goto ch_raise_exception;
/* lookup_at 13 10 =(0) */
  if ( !((ch_t = REF(10).value.table)->size) ) goto ch_notfound;
  (*(REF(13).tsdr)->finalize)(REF(13).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(13).value,0);
  REF(13).tsdr = qdatarepmap[ch_t->tsdr->number];
/* remove_at 12 10 =(0) */
  if ((ch_returncode = remove_at_func(DEF(12),DEF(10),0)) != Normal)
     goto ch_raise_exception;
/* block , 5 */
  if((ch_returncode = che_block(QUAL(5),sched)) != Normal)
     goto ch_raise_exception;
/* privatize 10 */
  if (REF(10).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(10))) != Normal)
       goto ch_raise_exception;
/* lookup_at 14 10 =(0) */
  if ( !((ch_t = REF(10).value.table)->size) ) goto ch_notfound;
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(14).value,0);
  REF(14).tsdr = qdatarepmap[ch_t->tsdr->number];
/* remove_at 15 10 =(0) */
  if ((ch_returncode = remove_at_func(DEF(15),DEF(10),0)) != Normal)
     goto ch_raise_exception;
/* endblock */
  che_endblock(sched);
/* branch , 28 */
   goto c28;
c26:
/* chs_lit 15 , "hprof" */
  if( !chs_lit(DEF(15),"hprof") ) goto ch_depletion;
c28:
/* chs_lit 16 , "pathReadObj" */
  if( !chs_lit(DEF(16),"pathReadObj") ) goto ch_depletion;
/* chs_lit 17 , "" */
  if( !chs_lit(DEF(17),"") ) goto ch_depletion;
  current->ip = 5;
cb30:
/* call 9.2.2 16 17 18 , 6 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(9)DOT(2)DOT(2),
          arguments[1] = DEF(16),
          arguments[2] = DEF(17),
          arguments[3] = DEF(18),
          arguments[3+1] = nil,& arguments[0]),QUAL(6),sched)) != Normal)
     goto ch_raise_exception;
  return;
c31:
/* unwrap 19 18 , 7 */
  if ((ch_returncode = che_unwrap(DEF(19),DEF(18),QUAL(7),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 7;
cb32:
/* call 19 15 20 , 8 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(19),
          arguments[1] = DEF(15),
          arguments[2] = DEF(20),
          arguments[2+1] = nil,& arguments[0]),QUAL(8),sched)) != Normal)
     goto ch_raise_exception;
  return;
c33:
/* unwrap 21 20 , 9 */
  if ((ch_returncode = che_unwrap(DEF(21),DEF(20),QUAL(9),sched)) != Normal)
     goto ch_raise_exception;
/* copy 22 10 */
  if((ch_returncode = cp_table(& ch_val, REF(10).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22).value = ch_val;
  REF(22).tsdr = & dr_table;
/* initget 23 22 , 0,0 */
  (*(REF(23).tsdr)->finalize)(REF(23).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(23),DEF(22),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c36:
/* get_or_goto 23 22 , 66 */
  if ((ch_returncode = get_selected_object(DEF(23),DEF(22),sched)) != Normal)
     goto c66;
/* discard 24 */
  (*(REF(24).tsdr)->finalize)(REF(24).value,F_DISCARD,sched);
  REF(24).tsdr = & dr_bottom;
/* chs_lit 25 , "Module " */
  if( !chs_lit(DEF(25),"Module ") ) goto ch_depletion;
/* concat 24 25 23 */
  if ((ch_returncode = che_concat(DEF(24),DEF(25),DEF(23),sched)) != Normal)
     goto ch_raise_exception;
/* discard 25 */
  (*(REF(25).tsdr)->finalize)(REF(25).value,F_DISCARD,sched);
  REF(25).tsdr = & dr_bottom;
  current->ip = 10;
cb41:
/* call 9.1.1 24 , 10 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(9)DOT(1)DOT(1),
          arguments[1] = DEF(24),
          arguments[1+1] = nil,& arguments[0]),QUAL(10),sched)) != Normal)
     goto ch_raise_exception;
  return;
c42:
/* copy 26 21 */
  if((ch_returncode = cp_table(& ch_val, REF(21).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(26).tsdr)->finalize)(REF(26).value,F_DISCARD,sched);
  REF(26).value = ch_val;
  REF(26).tsdr = & dr_table;
/* initget 27 26 , 0,0 */
  (*(REF(27).tsdr)->finalize)(REF(27).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(27),DEF(26),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c44:
/* get_or_goto 27 26 , 63 */
  if ((ch_returncode = get_selected_object(DEF(27),DEF(26),sched)) != Normal)
     goto c63;
/* notequal . 27.1 23 , 44 */
  if ( !eq_table(REF(27)DOT(1).value,REF(23).value) ) goto c44;
/* discard 28 */
  (*(REF(28).tsdr)->finalize)(REF(28).value,F_DISCARD,sched);
  REF(28).tsdr = & dr_bottom;
/* chs_lit 28 , "----" */
  if( !chs_lit(DEF(28),"----") ) goto ch_depletion;
  current->ip = 13;
cb49:
/* call 9.1.1 28 , 10 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(9)DOT(1)DOT(1),
          arguments[1] = DEF(28),
          arguments[1+1] = nil,& arguments[0]),QUAL(10),sched)) != Normal)
     goto ch_raise_exception;
  return;
c50:
/* copy 29 27.3 */
  if((ch_returncode = cp_table(& ch_val, REF(27)DOT(3).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(29).tsdr)->finalize)(REF(29).value,F_DISCARD,sched);
  REF(29).value = ch_val;
  REF(29).tsdr = & dr_table;
/* initget 30 29 , 0,0 */
  (*(REF(30).tsdr)->finalize)(REF(30).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(30),DEF(29),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c59:
c52:
/* get_or_goto 30 29 , 60 */
  if ((ch_returncode = get_selected_object(DEF(30),DEF(29),sched)) != Normal)
     goto c60;
/* discard 31 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  REF(31).tsdr = & dr_bottom;
/* discard 32 */
  (*(REF(32).tsdr)->finalize)(REF(32).value,F_DISCARD,sched);
  REF(32).tsdr = & dr_bottom;
  current->ip = 16;
cb55:
/* call 5 30 31 , 11 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(5),
          arguments[1] = DEF(30),
          arguments[2] = DEF(31),
          arguments[2+1] = nil,& arguments[0]),QUAL(11),sched)) != Normal)
     goto ch_raise_exception;
  return;
c56:
/* ilit 33 , 8 */
  REF(33).value.integer = 8;
  REF(33).tsdr = & dr_integer;
  current->ip = 18;
cb57:
/* call 8 31 33 32 , 12 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(8),
          arguments[1] = DEF(31),
          arguments[2] = DEF(33),
          arguments[3] = DEF(32),
          arguments[3+1] = nil,& arguments[0]),QUAL(12),sched)) != Normal)
     goto ch_raise_exception;
  return;
c58:
/* call 9.1.1 32 , 10 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(9)DOT(1)DOT(1),
          arguments[1] = DEF(32),
          arguments[1+1] = nil,& arguments[0]),QUAL(10),sched)) != Normal)
     goto ch_raise_exception;
  return;
c60:
/* endget 30 29 */
  end_selector(DEF(30),DEF(29),sched,GET);
/* discard 29 */
  (*(REF(29).tsdr)->finalize)(REF(29).value,F_DISCARD,sched);
  REF(29).tsdr = & dr_bottom;
/* branch , 44 */
   goto c44;
c63:
/* endget 27 26 */
  end_selector(DEF(27),DEF(26),sched,GET);
/* discard 26 */
  (*(REF(26).tsdr)->finalize)(REF(26).value,F_DISCARD,sched);
  REF(26).tsdr = & dr_bottom;
/* branch , 36 */
   goto c36;
c66:
/* endget 23 22 */
  end_selector(DEF(23),DEF(22),sched,GET);
/* discard 22 */
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22).tsdr = & dr_bottom;
/* return 9 */
  if (ch_caller = do_return(REF(9).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(9).value);
  REF(9).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c71:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
